; SidWine 2 C64 Online Music Competition vote pgr
; Tognon Stefano
; (c) 2003 Ice Team
;
; dasm source code

 processor 6502
 org 2049

 ;=================================
 ; BASIC startup program
 ;=================================
 dc.b $0b,$08,$e8,$03,$9e,"2061",0,0,0
 org 2061

SCREEN     = $E544    ; clean the screen
SET_COOR   = $E50C    ; set x/y coord
PUT_CHAR   = $E716    ; put a char in the screen
STRING     = $AB1E    ; put a string
RASTER0    = 0

; color address for mark music effect
C_AA  = $400+6*40+4
C_BB  = $400+6*40+5
C_CC  = $400+6*40+6
C_DD  = $400+6*40+7
C_EE  = $400+6*40+8

color
CO_A0 = 6+16
CO_AA = 14*16+6
CO_B0 = 3+16
CO_BB = 13*16+3
CO_C0 = 5+16
CO_CC = 7*16+5
CO_D0 = 8+16
CO_DD = 10*16+8
CO_E0 = 2+16
CO_EE = 4*16+2

initmusic  = $4400
playmusic  = $4403

enableGraphics:             ; set pointer for graphics data
      lda  $d018
      ora  #$08
      and  #$f8
      sta  $d018
                            ; enable hires bitmap mode
      lda  $d011
      ora  #$20
      sta  $d011
      lda  $d016
      and  #$EF
      sta  $d016
                            ; copy color to screen coord
      ldx #39
iscr1:
N     SET  0
      REPEAT 25
      lda  s2+N*40,x
      sta  $400+N*40,x
N     SET  N+1
      REPEND
      dex
      bmi iscrdone1
      jmp iscr1
iscrdone1:

      lda  #$00
      jsr  initmusic
      lda #$0f
      sta $d418

; install raster interrupt for music
initraster:
      sei
      lda  #<raster0
      sta  $0314
      lda  #>raster0
      sta  $0315
      lda  #RASTER0                    ;Set low bits of raster
      sta  $d012                       ;position
      lda  $d011
      and  #$7f                        ;Set high bit of raster
      sta  $d011                       ;position (0)
      lda  #$7f                        ;Set timer interrupt off
      sta  $dc0d

      ;lda #$81
      ;ldx #$01
      ;sta $dd0d
      ;stx $dd0e

      lda  #$01                        ;Set raster interrupt on
      sta  $d01a
      lda  $dc0d                       ;Acknowledge timer interrupt
      cli

aaa:  jsr  key
      jmp aaa

raster0:
      inc  $d019
      jsr  playmusic

      lda  $FF                    ; timing for cycle effect
      cmp  #$FF
      bne  isE0

      ;show AA,BB,CC,DD and EE
      lda  #CO_AA
      sta  C_AA
      lda  #CO_BB
      sta  C_BB
      lda  #CO_CC
      sta  C_CC
      lda  #CO_DD
      sta  C_DD
      lda  #CO_EE
      sta  C_EE
      jmp  $ea81

isE0:
      cmp  #$FE
      bne  isDD

      ;show AA,BB,CC,DD and E0
      lda  #CO_AA
      sta  C_AA
      lda  #CO_BB
      sta  C_BB
      lda  #CO_CC
      sta  C_CC
      lda  #CO_DD
      sta  C_DD
      lda  #CO_E0
      sta  C_EE
      jmp  $ea81

isDD:
      cmp  #$FD
      bne  isD0

      ; show AA,BB,CC,DD
      lda  #CO_AA
      sta  C_AA
      lda  #CO_BB
      sta  C_BB
      lda  #CO_CC
      sta  C_CC
      lda  #CO_DD
      sta  C_DD
      lda  #17
      sta  C_EE
      jmp  $ea81

isD0:
      cmp  #$FC
      bne  isCC

      ; show AA,BB,CC,D0
      lda  #CO_AA
      sta  C_AA
      lda  #CO_BB
      sta  C_BB
      lda  #CO_CC
      sta  C_CC
      lda  #CO_D0
      sta  C_DD
      lda  #17
      sta  C_EE
      jmp  $ea81

isCC:
      cmp  #$FB
      bne  isC0

      ; show AA,BB,CC
      lda  #CO_AA
      sta  C_AA
      lda  #CO_BB
      sta  C_BB
      lda  #CO_CC
      sta  C_CC
      lda  #17
      sta  C_DD
      sta  C_EE
      jmp  $ea81

isC0:
      cmp  #$FA
      bne  isBB

      ; show AA,BB,C0
      lda  #CO_AA
      sta  C_AA
      lda  #CO_BB
      sta  C_BB
      lda  #CO_C0
      sta  C_CC
      lda  #17
      sta  C_DD
      sta  C_EE
      jmp  $ea81

isBB:
      cmp  #$F9
      bne  isB0

      ; show AA,BB
      lda  #CO_AA
      sta  C_AA
      lda  #CO_BB
      sta  C_BB
      lda  #17
      sta  C_CC
      sta  C_DD
      sta  C_EE
      jmp  $ea81

isB0:
      cmp  #$F8
      bne  isAA

      ; show AA,B0
      lda  #CO_AA
      sta  C_AA
      lda  #CO_B0
      sta  C_BB
      lda  #17
      sta  C_CC
      sta  C_DD
      sta  C_EE
      jmp  $ea81

isAA:
      cmp  #$F7
      bne  isA0

      ; show AA
      lda  #CO_AA
      sta  C_AA
      lda  #17
      sta  C_BB
      sta  C_CC
      sta  C_DD
      sta  C_EE
      jmp  $ea81
isA0:
      cmp  #$F6
      bne  go_exit

      ; show A0
      lda  #CO_A0
      sta  C_AA
      lda  #17
      sta  C_BB
      sta  C_CC
      sta  C_DD
      sta  C_EE

go_exit:
      jmp  $ea81



disableGraphics:            ; set pointer for text data
                            ; enable text mode standard
      lda  $d011
      and  #$dF
      sta  $d011

      lda #21
      sta $d018
      lda #8
      sta $d016
      rts

      
      ; read a char from the queue
key:
      jsr  $FF9F
      jsr  $FFE4
      cmp  #0
      bne  skipExit
Exit:
      rts
skipExit:
      cmp  #65
      bmi  Exit
      cmp  #77
      bpl  Exit
      pha

; stop music
      ldy  #$14
Loop:
      sty  $D418

      ldx  #20
Loop2:
      jsr  $EEB3
      dex
      bne  Loop2
      dey
      bne  Loop

; disable interrupt
      ldx #0                          ; stop NMI and IRQ interrupts
      stx $d01a
      lda $d019
      sta $d019

      lda #$7f
      sta $dd0d
      lda $dd0d
      lda #8
      sta $dd0e

      cli
      lda  #$31
      sta  $314
      lda  #$EA
      sta  $315
      lda  #$47
      sta  $318
      lda  #$FE
      sta  $319
      sei

      lda #$25
      ldx #$40
      sta $dc04
      stx $dc05
      lda #$81
      ldx #$01
      sta $dc0d
      stx $dc0e

      jsr  disableGraphics
      jsr  SCREEN
      lda  #00
      sta  53281
      lda  #00
      sta  53280

; load the needed file
      pla
      sta  nA

                   ; insert the call to load and pgr execute to safe area
      lda  #$20
      sta  $9000
      lda  #$D5
      sta  $9001
      lda  #$FF
      sta  $9002
      lda  #$4C
      sta  $9003
      lda  #$0d
      sta  $9004
      lda  #$08
      sta  $9005

      jsr  $FFE7   ; clall
      jsr  $FF8A   ; restore

      lda  #$01
      ldx  #$08
      ldy  #$01
      jsr  $FFBA

      lda  #1
      ldx  #<nA
      ldy  #>nA
      jsr  $FFBD

      lda  #$00
      ldx  #$FF
      ldy  #$FF
      jmp  $9000

nA: .byte 0



 org 8192
 .incbin "b3.raw"
s2:
 .incbin "b2.raw"
 
 org $4400
 .incbin "music.bin"

